#Powershell-Script by Thomas Windscheif
#http://microlinc.homeip.net
#Link to Script-Project-Page: http://microlinc.homeip.net/index.php?lev1=7&lev2=14&lev3=&id=231
#process active check tool
#Ver 1.2 2014/07/14
cls

#works with Server 2008R2

#here you put in the name of the process being checked (without .exe)
$processname="explorer";

#DNS oder IP des SMTP-Servers
$smtpsrvname="127.0.0.1"
#Port des SMTP-Listeners (default: 25)
$smtpport=25;

$mailsender="admin@contoso.com";
$mailreceiver="admin@contoso.com";

#taskname of the task to be restarted
$starttask="start_explorer"

function restart_proc {
#taskscheduler
#start task
#http://www.vistax64.com/powershell/134287-running-command-line-script-within-powershell.html
invoke-expression "schtasks /run /TN $starttask"
}


function notify-mail {
Param(
[Parameter(Mandatory=$true)][string]$subject,
[parameter(Mandatory=$true)][string]$msg,
[switch]$priority
)

#parts from http://blogs.msdn.com/b/rkramesh/archive/2012/03/16/sending-email-using-powershell-script.aspx
$mailobj = new-object Net.Mail.MailMessage;
$smtpserver = new-object Net.Mail.SmtpClient($smtpsrvname);
$mailobj.From = $mailsender;
$mailobj.ReplyTo = $mailsender;
$mailobj.To.Add($mailreceiver);
#X-Priority high / marks as urgent
if ($priority) {
$mailobj.priority = "High";
}
$mailobj.subject = $subject;
$mailobj.body = $msg;

$smtpserver.Send($mailobj);
}


if (!(get-process -Name $processname -ErrorAction SilentlyContinue)) {
	write-host "process `"$processname`" isn't running!`ntrying a restart of scheduled task`nnotify via email" -Foregroundcolor red
	notify-mail -subject "process $processname is not runnig - trying auto restart" -msg "monitored process `"$processname`" is not running, trying to restart the scheduled task" -priority;
	start-sleep -Seconds 1
	restart_proc;
	start-sleep -Seconds 5
	if (!(get-process -Name $processname -ErrorAction SilentlyContinue)) {
		write-host "process `"$processname`" couldn't be restartet!" -Foregroundcolor red
		notify-mail -subject "restart of $processname failed" -msg "monitored process `"$processname`" didn't start. Please check the scheduled task `"$starttask`"" -priority;
	} else {
		write-host "process `"$processname`" runs" -Foregroundcolor green
		notify-mail -subject "restart of $processname successfull" -msg "monitored process `"$processname`" is running now. There is nothing to do for you";
	}
} else {
	write-host "process `"$processname`" runs" -Foregroundcolor green
}